//+------------------------------------------------------------------+
//|                                       Better Bollinger bands.mq4 |
//|                                                           mladen |
//|                                   mrtools added nrpma,alerts,mtf |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  Green
#property indicator_color5  Green 
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2 

//
//
//
//
//

extern string TimeFrame            = "current time frame";
extern int    BandsLength          = 20;
extern double BandsDeviation       = 2.0; 
extern int    AppliedPrice         = PRICE_CLOSE;
extern bool   MultiColor           = true;

extern bool   alertsOn             = true;
extern bool   alertsOnCurrent      = false;
extern bool   alertsOnBBreak       = true;
extern bool   alertsOnSlope        = true;
extern bool   alertsOnPriceCrossMa = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;

//
//
//
//
//

double ma[];
double maDa[];
double maDb[];
double upBand[];
double dnBand[];
double trend[];
double slope[];
double trends[];
double tBuffer[][4];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,ma);
   SetIndexBuffer(1,maDa);
   SetIndexBuffer(2,maDb);
   SetIndexBuffer(3,upBand);
   SetIndexBuffer(4,dnBand);
   SetIndexBuffer(5,trend);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trends);

    //
    //
    //
    //
    //
   
    indicatorFileName = WindowExpertName();
    returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
    timeFrame         = stringToTimeFrame(TimeFrame);
      
    IndicatorShortName(timeFrameToString(timeFrame)+"   better bollinger bands ");    
   return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iMt1 0
#define iMt2 1
#define iUt1 2
#define iUt2 3

//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    limit,i,r;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars);
         if (returnBars)  { ma[0] = limit+1; return(0); }
         if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);         
         
   //
   //
   //
   //
   //

   double alpha =  2.0/(BandsLength+1.0);
   if (timeFrame == Period())
   {
     if (MultiColor && slope[limit]==-1) CleanPoint(limit,maDa,maDb);  
       for (i=limit, r=Bars-i-1; i>=0; i--,r++)
       {
          double price = iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i);
         
          //
          //
          //
          //
          //
         
            tBuffer[r][iMt1] = tBuffer[r-1][iMt1] + alpha*(price           -tBuffer[r-1][iMt1]);
            tBuffer[r][iUt1] = tBuffer[r-1][iUt1] + alpha*(tBuffer[r][iMt1]-tBuffer[r-1][iUt1]);
               double dt  = ((2-alpha)*tBuffer[r][iMt1]-tBuffer[r][iUt1])/(1-alpha);
            
            tBuffer[r][iMt2] = tBuffer[r-1][iMt2] + alpha*(MathAbs(price-dt)-tBuffer[r-1][iMt2]);
            tBuffer[r][iUt2] = tBuffer[r-1][iUt2] + alpha*(tBuffer[r][iMt2] -tBuffer[r-1][iUt2]);
               double dt2 = ((2-alpha)*tBuffer[r][iMt2]-tBuffer[r][iUt2])/(1-alpha);

         //
         //
         //
         //
         //
         
         ma[i]     = dt;
         upBand[i] = dt+BandsDeviation*dt2;
         dnBand[i] = dt-BandsDeviation*dt2;
         maDa[i]   = EMPTY_VALUE;
         maDb[i]   = EMPTY_VALUE;
         slope[i]  = slope[i+1];
         trend[i]  = trend[i+1];
         trends[i] = trends[i+1];

            if (ma[i] < ma[i+1])     slope[i]  = -1;
            if (ma[i] > ma[i+1])     slope[i]  =  1;
            if (High[i] > upBand[i]) trend[i]  = -1;
            if (Low[i]  < dnBand[i]) trend[i]  =  1;
            if (Close[i] < ma[i+1])  trends[i] = -1;
            if (Close[i] > ma[i+1])  trends[i] =  1;
            if (MultiColor && slope[i] == -1) PlotPoint(i,maDa,maDb,ma);
            
         
      }
      manageAlerts();
      return(0);            
   }
   
   //
   //
   //
   //
   //
      
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (MultiColor && slope[limit]==-1) CleanPoint(limit,maDa,maDb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ma[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,0,y);
         maDa[i]   = EMPTY_VALUE;
         maDb[i]   = EMPTY_VALUE;
         upBand[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,3,y);
         dnBand[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,4,y);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,5,y);
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,6,y);
         trends[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,7,y);

   }
   if (MultiColor) for (i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,maDa,maDb,ma);
   manageAlerts();            
   return(0);
}



//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//
//
//
//
//

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnBBreak && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar," low price closed below lower band ");
            if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar," high price closed above upper band ");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time2,mess2,whichBar," Better bands ma sloping up ");
            if (slope[whichBar] == -1) doAlert(time2,mess2,whichBar," Better bands ma sloping down ");
         } 
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnPriceCrossMa && trends[whichBar] != trends[whichBar+1])
         {
            if (trends[whichBar] ==  1) doAlert(time3,mess3,whichBar," price crossed center ma up ");
            if (trends[whichBar] == -1) doAlert(time3,mess3,whichBar," price crossed center ma down ");
         }                       
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Better Bollinger Band "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


